import { ChannelInterface } from "prompt-anything";
import { DiscordVisual } from "./visuals/DiscordVisual";
import { MenuVisual } from "./visuals/MenuVisual";
import { MessageVisual } from "./visuals/MessageVisual";
import { Message, MessageOptions, TextChannel } from 'discord.js';
export declare class DiscordChannel implements ChannelInterface<Message> {
    id: string;
    channel: TextChannel;
    messages: Message[];
    constructor(channel: TextChannel);
    static DEFAULT_OPTIONS: MessageOptions;
    /**
     * Store all messages sent within this channel
     * @param message Message to store
     */
    storeMessages(message: Message | Message[]): void;
    sendMenuVisual(visual: MenuVisual): Promise<Message>;
    sendMessageVisual(visual: MessageVisual): Promise<Message | Message[]>;
    send(visual: DiscordVisual): Promise<Message | Message[]>;
}
